<app-header-organization [data]="organization" />

<div [ngClass]="['organization-detail', jds.mt(30), jds.mb(70), jds.mx(0)]">
  <div [ngClass]="jds.container">
    <div [ngClass]="jds.row">
      <aside [ngClass]="[jds.col(3)]">
        <jds-bi-accordion
          #acc="jdsBiAccordion"
          [destroyOnHide]="true"
          [closeOthers]="false"
          [activeIds]="[
            'accordion-topic',
            'accordion-mapset-type',
            'accordion-classification',
            'accordion-classification-indicator',
            'accordion-quality-data',
            'accordion-dataset-tags',
            'accordion-license',
            'accordion-category-indicator'
          ]"
          colorScheme="blue"
        >
          <!-- Filter Topic -->
          @if (
            vm.filterCatalog() === 'dataset' ||
            vm.filterCatalog() === 'visualization'
          ) {
            <!-- Filter Topic Satu Data -->
            <jds-bi-panel
              id="accordion-topic"
              title="Topik"
            >
              <ng-template jdsBiPanelContent>
                @if (vm.listTopicSatuData(); as listTopicSatuData) {
                  @switch (listTopicSatuData.status) {
                    @case ('loading') {
                      <app-skeleton-filter />
                    }
                    @case ('success') {
                      <app-filter-topic
                        [data]="listTopicSatuData.data.list"
                        [filter]="vm.filterTopic()"
                        (filterChange)="vm.handleFilterTopic($event)"
                      />
                    }
                  }
                }
              </ng-template>
            </jds-bi-panel>
          }

          @if (vm.filterCatalog() === 'mapset') {
            <!-- Filter Topic Satu Peta -->
            <jds-bi-panel
              id="accordion-topic"
              title="Topik"
            >
              <ng-template jdsBiPanelContent>
                @if (vm.listTopicSatuPeta(); as listTopicSatuPeta) {
                  @switch (listTopicSatuPeta.status) {
                    @case ('loading') {
                      <app-skeleton-filter />
                    }
                    @case ('success') {
                      <app-filter-topic
                        [data]="listTopicSatuPeta.data.list"
                        [filter]="vm.filterTopic()"
                        (filterChange)="vm.handleFilterTopic($event)"
                      />
                    }
                  }
                }
              </ng-template>
            </jds-bi-panel>
          }

          <!-- Filter Mapset Type -->
          @if (vm.filterCatalog() === 'mapset') {
            <jds-bi-panel
              id="accordion-mapset-type"
              title="Tipe Peta"
            >
              <ng-template jdsBiPanelContent>
                @if (vm.listMapsetType(); as listMapsetType) {
                  @switch (listMapsetType.status) {
                    @case ('loading') {
                      <app-skeleton-filter />
                    }
                    @case ('success') {
                      <app-filter-mapset-type
                        [data]="listMapsetType.data.list"
                        [filter]="vm.filterType()"
                        (filterChange)="vm.handleFilterMapsetType($event)"
                      />
                    }
                  }
                }
              </ng-template>
            </jds-bi-panel>
          }

          <!-- Filter Classification -->
          @if (
            vm.filterCatalog() === 'dataset' ||
            vm.filterCatalog() === 'mapset' ||
            vm.filterCatalog() === 'visualization'
          ) {
            <!-- Filter Classification Dataset -->
            <jds-bi-panel
              id="accordion-classification"
              title="Klasifikasi"
            >
              <ng-template jdsBiPanelContent>
                @if (vm.listClassification(); as listClass) {
                  @switch (listClass.status) {
                    @case ('loading') {
                      <app-skeleton-filter />
                    }
                    @case ('success') {
                      <app-filter-classification
                        [data]="listClass.data.list"
                        [filter]="vm.filterClassification()"
                        (filterChange)="vm.handleFilterClassification($event)"
                      />
                    }
                  }
                }
              </ng-template>
            </jds-bi-panel>
          }

          @if (vm.filterCatalog() === 'indicator') {
            <!-- Filter Classification Indicator -->
            <jds-bi-panel
              id="accordion-classification-indicator"
              title="Klasifikasi"
            >
              <ng-template jdsBiPanelContent>
                @if (vm.listClassificationIndicator(); as listClass) {
                  @switch (listClass.status) {
                    @case ('loading') {
                      <app-skeleton-filter />
                    }
                    @case ('success') {
                      <app-filter-classification-indicator
                        [data]="listClass.data.list"
                        [filter]="vm.filterClassification()"
                        (filterChange)="vm.handleFilterClassification($event)"
                      />
                    }
                  }
                }
              </ng-template>
            </jds-bi-panel>
          }

          <!-- Filter Quality Data -->
          @if (vm.filterCatalog() === 'dataset') {
            <jds-bi-panel
              id="accordion-quality-data"
              title="Kualitas Data"
            >
              <ng-template jdsBiPanelContent>
                <app-filter-quality
                  [data]="vm.listDatasetQuality()"
                  [filter]="vm.filterQuality()"
                  (filterChange)="vm.handleFilterQuality($event)"
                />
              </ng-template>
            </jds-bi-panel>
          }

          <!-- Filter Tags -->
          @if (vm.filterCatalog() === 'dataset') {
            <jds-bi-panel
              id="accordion-dataset-tags"
              title="Tags"
            >
              <ng-template jdsBiPanelContent>
                @if (vm.listDatasetTags(); as listDatasetTags) {
                  @switch (listDatasetTags.status) {
                    @case ('loading') {
                      <app-skeleton-filter />
                    }
                    @case ('success') {
                      <app-filter-dataset-tags
                        [data]="listDatasetTags.data.list"
                        [filter]="vm.filterTags()"
                        (filterChange)="vm.handleFilterTags($event)"
                      />
                    }
                  }
                }
              </ng-template>
            </jds-bi-panel>
          }

          <!-- Filter License -->
          @if (vm.filterCatalog() === 'dataset') {
            <jds-bi-panel
              id="accordion-license"
              title="Lisensi"
            >
              <ng-template jdsBiPanelContent>
                @if (vm.listDatasetLicense(); as listDatasetLicense) {
                  @switch (listDatasetLicense.status) {
                    @case ('loading') {
                      <app-skeleton-filter />
                    }
                    @case ('success') {
                      <app-filter-license
                        [data]="listDatasetLicense.data.list"
                        [filter]="vm.filterLicense()"
                        (filterChange)="vm.handleFilterLicense($event)"
                      />
                    }
                  }
                }
              </ng-template>
            </jds-bi-panel>
          }

          @if (vm.filterCatalog() === 'indicator') {
            <!-- Filter Category Indicator -->
            <jds-bi-panel
              id="accordion-category-indicator"
              title="Kategori"
            >
              <ng-template jdsBiPanelContent>
                @if (vm.listIndicatorCategory(); as listIndicatorCategory) {
                  @switch (listIndicatorCategory.status) {
                    @case ('loading') {
                      <app-skeleton-filter />
                    }
                    @case ('success') {
                      <app-filter-category-indicator
                        [data]="listIndicatorCategory.data.list"
                        [filter]="vm.filterCategory()"
                        (filterChange)="vm.handleFilterCategory($event)"
                      />
                    }
                  }
                }
              </ng-template>
            </jds-bi-panel>
          }
        </jds-bi-accordion>
      </aside>

      <div [ngClass]="[jds.col(9)]">
        <!-- Search Catalog -->
        <div [ngClass]="[jds.mb(16)]">
          <app-search-catalog
            [catalog]="vm.filterCatalog()"
            [search]="vm.filterSearch()"
            (searchChange)="vm.handleFilterSearch($event)"
          />
        </div>

        <!-- Tab Catalog -->
        <div [ngClass]="[jds.mb(16)]">
          <app-tab-catalog
            [catalog]="vm.filterCatalog()"
            (catalogChange)="vm.handleFilterCatalog($event)"
          />
        </div>

        <div
          [ngClass]="[
            jds.d('flex'),
            jds.alignItems('center'),
            jds.justifyContent('between'),
            jds.mb(24)
          ]"
        >
          <!-- Suggestion Catalog -->
          @switch (vm.filterCatalog()) {
            @case ('dataset') {
              @if (vm.listDataset(); as listDataset) {
                @switch (listDataset.status) {
                  @case ('loading') {
                    <div class="wrapper-skeleton">
                      <ngx-skeleton-loader
                        [theme]="{
                          width: '25%',
                          'border-radius': '0',
                          height: '22px',
                          'margin-bottom': '0'
                        }"
                      />
                    </div>
                  }
                  @case ('success') {
                    @if (listDataset.data.list.length > 0) {
                      <span [ngClass]="[jds.fs(14)]">
                        <strong>
                          {{
                            listDataset.data.pagination.total_items
                              | number: '1.0-0' : 'id'
                          }}
                        </strong>
                        Dataset ditemukan
                      </span>
                    } @else {
                      <span [ngClass]="[jds.fs(14)]">
                        Dataset tidak ditemukan
                      </span>
                    }
                  }
                }
              }
            }
            @case ('mapset') {
              @if (vm.listMapset(); as listMapset) {
                @switch (listMapset.status) {
                  @case ('loading') {
                    <div class="wrapper-skeleton">
                      <ngx-skeleton-loader
                        [theme]="{
                          width: '25%',
                          'border-radius': '0',
                          height: '22px',
                          'margin-bottom': '0'
                        }"
                      />
                    </div>
                  }
                  @case ('success') {
                    @if (listMapset.data.list.length > 0) {
                      <span [ngClass]="[jds.fs(14)]">
                        <strong>
                          {{
                            listMapset.data.pagination.total_items
                              | number: '1.0-0' : 'id'
                          }}
                        </strong>
                        Mapset ditemukan
                      </span>
                    } @else {
                      <span [ngClass]="[jds.fs(14)]">
                        Mapset tidak ditemukan
                      </span>
                    }
                  }
                }
              }
            }
            @case ('indicator') {
              @if (vm.listIndicator(); as listIndicator) {
                @switch (listIndicator.status) {
                  @case ('loading') {
                    <div class="wrapper-skeleton">
                      <ngx-skeleton-loader
                        [theme]="{
                          width: '25%',
                          'border-radius': '0',
                          height: '22px',
                          'margin-bottom': '0'
                        }"
                      />
                    </div>
                  }
                  @case ('success') {
                    @if (listIndicator.data.list.length > 0) {
                      <span [ngClass]="[jds.fs(14)]">
                        <strong>
                          {{
                            listIndicator.data.pagination.total_items
                              | number: '1.0-0' : 'id'
                          }}
                        </strong>
                        Indikator ditemukan
                      </span>
                    } @else {
                      <span [ngClass]="[jds.fs(14)]">
                        Indikator tidak ditemukan
                      </span>
                    }
                  }
                }
              }
            }
            @case ('visualization') {
              @if (vm.listVisualization(); as listVisualization) {
                @switch (listVisualization.status) {
                  @case ('loading') {
                    <div class="wrapper-skeleton">
                      <ngx-skeleton-loader
                        [theme]="{
                          width: '25%',
                          'border-radius': '0',
                          height: '22px',
                          'margin-bottom': '0'
                        }"
                      />
                    </div>
                  }
                  @case ('success') {
                    @if (listVisualization.data.list.length > 0) {
                      <span [ngClass]="[jds.fs(14)]">
                        <strong>
                          {{
                            listVisualization.data.pagination.total_items
                              | number: '1.0-0' : 'id'
                          }}
                        </strong>
                        Visualisasi ditemukan
                      </span>
                    } @else {
                      <span [ngClass]="[jds.fs(14)]">
                        Visualisasi tidak ditemukan
                      </span>
                    }
                  }
                }
              }
            }
          }

          <!-- Sort Catalog -->
          <app-sort-catalog
            [catalog]="vm.filterCatalog()"
            [sort]="vm.filterSort()"
            (sortChange)="vm.handleFilterSort($event)"
          />
        </div>

        <!-- Quick Access Catalog -->
        @if (vm.hasFilterQuickAccess()) {
          <div [ngClass]="[vm.hasFilterQuickAccess() ? jds.mb(16) : '']">
            <div [ngClass]="jds.d('flex')">
              <div
                [style.minWidth.px]="100"
                [style.lineHeight.px]="32"
              >
                <span>Filter Aktif: </span>
              </div>
              <div>
                <!-- Quick Access Topic -->
                @if (
                  vm.filterCatalog() === 'dataset' ||
                  vm.filterCatalog() === 'visualization'
                ) {
                  @if (vm.listTopicSatuData(); as listTopicSatuData) {
                    @if (listTopicSatuData.isSuccess) {
                      <app-quick-access-catalog
                        [type]="'topic'"
                        [data]="listTopicSatuData.data.list"
                        [filter]="vm.filterTopic()"
                        (filterChange)="vm.handleFilterTopic($event)"
                      />
                    }
                  }
                }

                @if (vm.filterCatalog() === 'mapset') {
                  @if (vm.listTopicSatuPeta(); as listTopicSatuPeta) {
                    @if (listTopicSatuPeta.isSuccess) {
                      <app-quick-access-catalog
                        [type]="'topic'"
                        [data]="listTopicSatuPeta.data.list"
                        [filter]="vm.filterTopic()"
                        (filterChange)="vm.handleFilterTopic($event)"
                      />
                    }
                  }
                }

                <!-- Quick Access Mapset Type -->
                @if (vm.filterCatalog() === 'mapset') {
                  @if (vm.listMapsetType(); as listMapsetType) {
                    @if (listMapsetType.isSuccess) {
                      <app-quick-access-catalog
                        [type]="'mapset-type'"
                        [data]="listMapsetType.data.list"
                        [filter]="vm.filterType()"
                        (filterChange)="vm.handleFilterMapsetType($event)"
                      />
                    }
                  }
                }

                <!-- Quick Access Classification -->
                @if (
                  vm.filterCatalog() === 'dataset' ||
                  vm.filterCatalog() === 'mapset' ||
                  vm.filterCatalog() === 'visualization'
                ) {
                  @if (vm.listClassification(); as listClass) {
                    @if (listClass.isSuccess) {
                      <app-quick-access-catalog
                        [type]="'classification'"
                        [data]="listClass.data.list"
                        [filter]="vm.filterClassification()"
                        (filterChange)="vm.handleFilterClassification($event)"
                      />
                    }
                  }
                }

                <!-- Quick Access Classification Indicator -->
                @if (vm.filterCatalog() === 'indicator') {
                  @if (vm.listClassificationIndicator(); as listClass) {
                    @if (listClass.isSuccess) {
                      <app-quick-access-catalog
                        [type]="'classification-indicator'"
                        [data]="listClass.data.list"
                        [filter]="vm.filterClassification()"
                        (filterChange)="vm.handleFilterClassification($event)"
                      />
                    }
                  }
                }

                <!-- Quick Access Quality Data -->
                @if (vm.filterCatalog() === 'dataset') {
                  <app-quick-access-catalog
                    [type]="'quality'"
                    [data]="vm.listDatasetQuality()"
                    [filter]="vm.filterQuality()"
                    (filterChange)="vm.handleFilterQuality($event)"
                  />
                }

                <!-- Quick Access Tags -->
                @if (vm.filterCatalog() === 'dataset') {
                  @if (vm.listDatasetTags(); as listDatasetTags) {
                    @if (listDatasetTags.isSuccess) {
                      <app-quick-access-catalog
                        [type]="'dataset-tags'"
                        [data]="listDatasetTags.data.list"
                        [filter]="vm.filterTags()"
                        (filterChange)="vm.handleFilterTags($event)"
                      />
                    }
                  }
                }

                <!-- Quick Access License -->
                @if (vm.filterCatalog() === 'dataset') {
                  @if (vm.listDatasetLicense(); as listDatasetLicense) {
                    @if (listDatasetLicense.isSuccess) {
                      <app-quick-access-catalog
                        [type]="'license'"
                        [data]="listDatasetLicense.data.list"
                        [filter]="vm.filterLicense()"
                        (filterChange)="vm.handleFilterLicense($event)"
                      />
                    }
                  }
                }

                <!-- Quick Access Category Indicator -->
                @if (vm.filterCatalog() === 'indicator') {
                  @if (vm.listIndicatorCategory(); as listIndicatorCategory) {
                    @if (listIndicatorCategory.isSuccess) {
                      <app-quick-access-catalog
                        [type]="'category-indicator'"
                        [data]="listIndicatorCategory.data.list"
                        [filter]="vm.filterCategory()"
                        (filterChange)="vm.handleFilterCategory($event)"
                      />
                    }
                  }
                }

                <button
                  [size]="'sm'"
                  [ngClass]="[jds.me(8), jds.mb(8)]"
                  [variant]="'ghost'"
                  [colorScheme]="colorScheme"
                  (click)="vm.handleFilterClear()"
                  jdsBiButton
                  type="button"
                >
                  Hapus Semua
                </button>
              </div>
            </div>
          </div>
        }

        <!-- List Catalog -->
        @switch (vm.filterCatalog()) {
          <!-- List Catalog Dataset -->
          @case ('dataset') {
            @if (vm.listDataset(); as listDataset) {
              @switch (listDataset.status) {
                @case ('loading') {
                  <app-skeleton-catalog />
                }
                @case ('success') {
                  @if (listDataset.isFetching) {
                    <app-skeleton-catalog />
                  } @else if (listDataset.data.list.length > 0) {
                    @for (item of listDataset.data.list; track item.id) {
                      <app-list-dataset
                        [isAction]="false"
                        [data]="item"
                        [filterTag]="vm.filterTags()"
                        (filterTagChange)="vm.handleFilterTags($event)"
                      />
                    }

                    <jds-bi-pagination
                      [colorScheme]="colorScheme"
                      [perPageItems]="perPageItems"
                      [pagination]="listDataset.data.pagination"
                      [perPage]="vm.filterPerPage()"
                      [page]="vm.filterCurrentPage()"
                      (filterPerPage)="vm.handleFilterPerPage($event)"
                      (filterPage)="vm.handleFilterCurrentPage($event)"
                    />
                  } @else {
                    @if (vm.hasFilterSearch()) {
                      <app-list-empty type="dataset">
                        <h6>Maaf, hasil pencarian tidak ditemukan.</h6>
                        <p>
                          Dataset yang Anda cari tidak ditemukan atau terjadi
                          kesalahan penulisan kata kunci.
                        </p>
                      </app-list-empty>
                    } @else {
                      <app-list-empty type="dataset">
                        <h6>Maaf, belum ada Dataset yang dapat diakses.</h6>
                        <p>
                          Mohon coba kembali di lain waktu untuk mendapatkan
                          Dataset yang Anda cari.
                        </p>
                      </app-list-empty>
                    }
                  }
                }
              }
            }
          }
          <!-- List Catalog Mapset -->
          @case ('mapset') {
            @if (vm.listMapset(); as listMapset) {
              @switch (listMapset.status) {
                @case ('loading') {
                  <app-skeleton-catalog />
                }
                @case ('success') {
                  @if (listMapset.isFetching) {
                    <app-skeleton-catalog />
                  } @else if (listMapset.data.list.length > 0) {
                    @for (item of listMapset.data.list; track item.id) {
                      <app-list-mapset
                        [isAction]="false"
                        [data]="item"
                      />
                    }

                    <jds-bi-pagination
                      [colorScheme]="colorScheme"
                      [perPageItems]="perPageItems"
                      [pagination]="listMapset.data.pagination"
                      [perPage]="vm.filterPerPage()"
                      [page]="vm.filterCurrentPage()"
                      (filterPerPage)="vm.handleFilterPerPage($event)"
                      (filterPage)="vm.handleFilterCurrentPage($event)"
                    />
                  } @else {
                    @if (vm.hasFilterSearch()) {
                      <app-list-empty type="dataset">
                        <h6>Maaf, hasil pencarian tidak ditemukan.</h6>
                        <p>
                          Mapset yang Anda cari tidak ditemukan atau terjadi
                          kesalahan penulisan kata kunci.
                        </p>
                      </app-list-empty>
                    } @else {
                      <app-list-empty type="dataset">
                        <h6>Maaf, belum ada Mapset yang dapat diakses.</h6>
                        <p>
                          Mohon coba kembali di lain waktu untuk mendapatkan
                          Mapset yang Anda cari.
                        </p>
                      </app-list-empty>
                    }
                  }
                }
              }
            }
          }
          <!-- List Catalog Indicator -->
          @case ('indicator') {
            @if (vm.listIndicator(); as listIndicator) {
              @switch (listIndicator.status) {
                @case ('loading') {
                  <app-skeleton-catalog />
                }
                @case ('success') {
                  @if (listIndicator.isFetching) {
                    <app-skeleton-catalog />
                  } @else if (listIndicator.data.list.length > 0) {
                    @for (item of listIndicator.data.list; track item.id) {
                      <app-list-indicator
                        [isAction]="false"
                        [data]="item"
                      />
                    }

                    <jds-bi-pagination
                      [colorScheme]="colorScheme"
                      [perPageItems]="perPageItems"
                      [pagination]="listIndicator.data.pagination"
                      [perPage]="vm.filterPerPage()"
                      [page]="vm.filterCurrentPage()"
                      (filterPerPage)="vm.handleFilterPerPage($event)"
                      (filterPage)="vm.handleFilterCurrentPage($event)"
                    />
                  } @else {
                    @if (vm.hasFilterSearch()) {
                      <app-list-empty type="dataset">
                        <h6>Maaf, hasil pencarian tidak ditemukan.</h6>
                        <p>
                          Indikator yang Anda cari tidak ditemukan atau terjadi
                          kesalahan penulisan kata kunci.
                        </p>
                      </app-list-empty>
                    } @else {
                      <app-list-empty type="dataset">
                        <h6>Maaf, belum ada Indikator yang dapat diakses.</h6>
                        <p>
                          Mohon coba kembali di lain waktu untuk mendapatkan
                          Indikator yang Anda cari.
                        </p>
                      </app-list-empty>
                    }
                  }
                }
              }
            }
          }
          <!-- List Catalog Visualization -->
          @case ('visualization') {
            @if (vm.listVisualization(); as listVisualization) {
              @switch (listVisualization.status) {
                @case ('loading') {
                  <app-skeleton-catalog />
                }
                @case ('success') {
                  @if (listVisualization.isFetching) {
                    <app-skeleton-catalog />
                  } @else if (listVisualization.data.list.length > 0) {
                    @for (item of listVisualization.data.list; track item.id) {
                      <app-list-visualization
                        [isAction]="false"
                        [data]="item"
                      />
                    }

                    <jds-bi-pagination
                      [colorScheme]="colorScheme"
                      [perPageItems]="perPageItems"
                      [pagination]="listVisualization.data.pagination"
                      [perPage]="vm.filterPerPage()"
                      [page]="vm.filterCurrentPage()"
                      (filterPerPage)="vm.handleFilterPerPage($event)"
                      (filterPage)="vm.handleFilterCurrentPage($event)"
                    />
                  } @else {
                    @if (vm.hasFilterSearch()) {
                      <app-list-empty type="dataset">
                        <h6>Maaf, hasil pencarian tidak ditemukan.</h6>
                        <p>
                          Visualisasi yang Anda cari tidak ditemukan atau
                          terjadi kesalahan penulisan kata kunci.
                        </p>
                      </app-list-empty>
                    } @else {
                      <app-list-empty type="dataset">
                        <h6>Maaf, belum ada Visualisasi yang dapat diakses.</h6>
                        <p>
                          Mohon coba kembali di lain waktu untuk mendapatkan
                          Visualisasi yang Anda cari.
                        </p>
                      </app-list-empty>
                    }
                  }
                }
              }
            }
          }
        }
      </div>
    </div>
  </div>
</div>
